<template>
  <vl-map data-projection="EPSG:4326">
    <vl-view :zoom.sync="zoom" :center.sync="point" :rotation.sync="rotation"></vl-view>

    <vl-layer-tile>
      <vl-source-osm></vl-source-osm>
    </vl-layer-tile>

    <vl-feature>
      <vl-geom-point :coordinates="point"></vl-geom-point>
    </vl-feature>
  </vl-map>
</template>

<script>
import Vue from 'vue';
import {
  Map,
  OsmSource,
  TileLayer,
  Feature,
  Geoloc,
  PointGeom,
} from 'vuelayers';
import 'vuelayers/lib/style.css'; // needs css-loader

Vue.use(Map);
Vue.use(OsmSource);
Vue.use(TileLayer);
Vue.use(Feature);
Vue.use(PointGeom);
Vue.use(Geoloc);

const MAX_LONGITUDE = 90; // Map fail when it is bigger
const MIN_LONGITUDE = -90; // Map fail when it is lower

export default {
  name: 'MapComponent',
  data() {
    return {
      rotation: 0,
      zoom: 5,
    };
  },
  props: {
    latitude: {
      type: String,
      default: '0',
    },
    longitude: {
      type: String,
      default: '0',
    },
  },
  computed: {
    point() {
      let longitude = parseInt(this.longitude, 10);

      if (longitude > MAX_LONGITUDE) {
        longitude = MAX_LONGITUDE;
      } else if (longitude < MIN_LONGITUDE) {
        longitude = MIN_LONGITUDE;
      }

      return [parseInt(this.latitude, 10), longitude];
    },
  },
};
</script>
<style scoped lang="scss">
vl-map {
  height: 200px;
}
</style>
